/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 *		[d֐
 *
 *		dƒdł̏[dƒ~鎞肷邽߂̊֐܂݂܂B
 *
 * \par pLq
 *		AVR458: BC100ł ݓdȑ[d\n
 *		AVR463: BC100łƯِfdȑ[d
 *
 * \par :
 *		IȎAxׁ߲A߲אݒƎx޲ɂĂreadme.html
 *		B
 *
 * \author
 *		Atmel Corporation: http://www.atmel.com \n
 *		Support email: avr@atmel.com
 *
 * $Name$
 * $Revision: 4254 $
 * $RCSfile$
 * $URL: http://revisor.norway.atmel.com/AppsAVR8/avr458_Charging_Li-Ion_Batteries_with_BC100/trunk/code/IAR/chargefunc.c $
 * $Date: 2008-07-25 12:32:45 +0200 (fr, 25 jul 2008) $\n
 ******************************************************************************/

#include <ioavr.h>

#include "enums.h"
#include "structs.h"

#include "ADC.h"
#include "battery.h"
#include "chargefunc.h"
#include "main.h"
#include "menu.h"
#include "PWM.h"
#include "statefunc.h"
#include "time.h"

#ifdef NIMH
#include "NIMHspecs.h"
#endif // NIMH

#ifdef LIION
#include "LIIONspecs.h"
#endif // LIION

//******************************************************************************
// ϐ
//******************************************************************************
ChargeParameters_t ChargeParameters;	//! ConstantCurrent()ConstantVoltage()pҰێ\
HaltParameters_t HaltParameters;		//! HaltNow()pҰێ\

//******************************************************************************
// ֐
//******************************************************************************
/*! \brief dœdr[d
 *
 * ̊֐HaltNow()TRUEԂA܂\ref ABORT_IF_PWM_MIN
 * \ref ABORT_IF_PWM_MAX`APWMُ킪N܂ŁAdrɑ΂
 * (ChargeParameters.CurrentŐݒ肳ꂽ)d܂B\n
 * [dd́} \ref BAT_CURRENT_HYST ŕς蓾܂B\n
 * 呕u[d֎~ꍇAv킪~APWMo͂Ƃ܂Bdr[
 * d֎~̍}͂₳ȂȂAv킪ĂъJnď[dĊJ܂B
 *
 * \retval ChargeParameters.NextState	̒iKI̎̏
 * ُȋNȂȂACharge()ŉݒ肳ꂽł傤BȂ
 * ΁AHaltNow()V̏Ԃݒ肷ł傤B
 */
unsigned char ConstantCurrent(void)
{
	unsigned char error = FALSE,
				  wasStopped = FALSE;

	do	{
		ADC_Wait();										// A/Dϊҋ@
		if (BattControl[BattActive].ChargeInhibit) {	// 呕u[d֎~}ȂA[dꎞ~
			wasStopped = TRUE;							// (͒ʐM̑h߂łB)
			Time_Stop();
			OCR1B = 0;
		} else {										// ֎~vȂŁA[dp
			if (wasStopped) {
				wasStopped = FALSE;
				Time_Start();							// (vϐ͂ɂؾĂ܂B)
			}
			if ((ADCS.avgIBAT < 0) ||					// [ddChargeParameters.Current}BAT_CURRENT_HYSTɒ(+)
			    (ADCS.avgIBAT < (ChargeParameters.Current - BAT_CURRENT_HYST))) {

				if(!PWM_IncrementDutyCycle()) {			// ޭè ّs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MAX
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			} else if ((ADCS.avgIBAT >= 0) &&			// [ddChargeParameters.Current}BAT_CURRENT_HYSTɒ(-)
				 (ADCS.avgIBAT > (ChargeParameters.Current + BAT_CURRENT_HYST))) {

				if(!PWM_DecrementDutyCycle()) {			// ޭè ٌs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MIN
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			}
		}
	} while (!HaltNow() && !error);
	return(ChargeParameters.NextState);		// Charge()Ɏ̏ԂԂ܂B
											// ُ킪NꍇA͏[d̎̏Ԃł͂Ȃʂ̏Ԃ܂B
}

/*! \brief ꓾ődƍődœdr[d
 *
 * ̊֐͓dr[dɊւ{̋Kɏ]ď[dA4̉x͈͂ɑ
 * čő[ddƓdw肵܂B
 *
 * ID_|_x͈_|_őd__|_őd____
 * T0 |  0`10 |  IC/0.5IC | 4.10V/4.25 V
 * T1 | 10`45 |  IC       | 4.25V
 * T2 | 45`50 |  IC       | 4.15V
 * T3 | 50`60 |  IC       | 4.10V
 *
 * ex͈͂ɑ΂ődődHaltNow()TRUEԂA܂
 * \ref ABORT_IF_PWM_MIN  \ref ABORT_IF_PWM_MAX `ꊎPWMُ킪
 * ܂ŁAdrɈ܂B\n
 *
 * IC͓dr`ɈˑA1C܂B͓̎o^IDɂ
 * Đݒ肳ꂽőd͉łgpARIDQƕ\̉A܂
 * (RIDȂ[dĂ) \ref battery.h ̊ݒ̂ǂ炩ɂȂ
 * ܂B
 *
 * ܂Å֐͉x͈͊OAƁA0܂60z̏ꍇɏ[d
 * ~܂BɁA \ref LIIONspecs.h ܂ \ref NIMHspecs.h
 * Œ`x(\ref BAT_TEMPERATURE_MAX  \ref BAT_TEMPERATURE_MIN)𗊂
 * \ref HaltNow() ɂčs܂B
 *
 * 呕u[d֎~ꍇAv킪~APWMo͂Ƃ܂Bdr[
 * d֎~̍}͂₳ȂȂAv킪ĂъJnď[dĊJ܂B
 *
 * \retval ChargeParameters.NextState	̒iKI̎̏
 * ُȋNȂȂACharge()ŉݒ肳ꂽł傤BȂ
 * ΁AHaltNow()V̏Ԃݒ肷ł傤B
 *
 * \note x͈͂ \ref chargefunc.h Œ`Aődƍőd
 * \ref LIIONspecs.h Œ`܂B
 *
 * \note [dҰ̕ωɂ邱Ƃ"E"xh߂ɁA
 * \ref chargefunc.h Œ`鉷x˽ؼgp܂B
 */
unsigned char MaxVoltageAndCurrent (void)
{
	unsigned char error = FALSE, wasStopped = FALSE, tempRangeChange;

	signed char lastTempRange = -1;		// JԂɉ"s"xɐݒ肵Ȃ΂Ȃ܂B

	do {
		ADC_Wait();						// A/Dϊҋ@
		NTCLookUp();					// x擾
		if (BattControl[BattActive].ChargeInhibit) {	// 呕u[d֎~}ŁA(ԒʐMł̓drh~̂)
			wasStopped = TRUE;							// ~׸ސݒ
			Time_Stop();								// v~
			OCR1B = 0;									// PWMo0(Ȃ)w
		}
		else {											// 呕u[d֎~vȂŁA([dĊJ/p)
			if (wasStopped) {							// ~ȂA
				wasStopped = FALSE;						// ~׸މ
				Time_Start();							// vĊJ(~_̍ĊJ)
			}
			// x˽ؼ͑Jڒlӂł̑̕ϓ܂BOɐݒ肳ꂽ
			// x͈͂˽ؼEƐVxrAVx˽ؼ̌
			// ֗ꂽꍇɕω}܂B
			tempRangeChange = FALSE;	// x͈͂̕ύXȂƂ̉ŊJnB
			switch (lastTempRange) {
				case T0 :	/* 0`10 */
					if ((BattData.Temperature - T0) > TEMP_HYST) {		// ˽ؼ܂߂T0zŁA
						tempRangeChange = TRUE;							// x͈͕ω׸ސݒ
					}
					else {												// T0͈͓ŁA
					// ͈̔͂ɗ܂ȂǍKvłBdrdT0
					// ΂#1臒lȉȂA[ddő1.0CA[ddő
					// 4.10Vւ݂̒܂BdrdT0ɑ΂#1臒lȏ
					// A[ddő0.5CA[ddő4.25Vւ̒
					// ܂B
					//
					// ͓drd4.10VɓB鎞Ɉ"U"Jn
					// āAd0.5Cȉ̊ԂɓdrdU4.10VzƏI
					// Ǎ͊֐4.25V̈ۂ܂B
					// ͂ǂ̒xdȂ点܂B
						if (ADCS.VBAT <= BAT_VOLTAGE_MAX_T0) {					// ٓd4.10VȉŁA
							ChargeParameters.Voltage = BAT_VOLTAGE_MAX_T0;		// ő[dd=4.10V~ِw
							ChargeParameters.Current = BattData.MaxCurrent;		// ő[dd=1Cw
						}
						else {													// ٓd4.10VzŁA
							ChargeParameters.Voltage = BAT_VOLTAGE_MAX;			// ő[dd=4.20V~ِw
							ChargeParameters.Current = BattData.MaxCurrent/2;	// ő[dd=0.5Cw
						}
					}
					break;
				case T1 :	/* 10`45 */
					if ((BattData.Temperature - T1) > TEMP_HYST			// ˽ؼ܂߂T1͈͊OŁA
					  || (T0 - BattData.Temperature) > TEMP_HYST) {
						tempRangeChange = TRUE;							// x͈͕ω׸ސݒ
					}
					break;
				case T2 :	/* 45`50 */
					if ((BattData.Temperature - T2) > TEMP_HYST			// ˽ؼ܂߂T2͈͊OŁA
					  || (T1 - BattData.Temperature) >= TEMP_HYST) {
						tempRangeChange = TRUE;							// x͈͕ω׸ސݒ
					}
					break;
				case T3 :	/* 50`60 */
					if ((T2 - BattData.Temperature) > TEMP_HYST) {		// ˽ؼ܂߂T2zŁA
						tempRangeChange = TRUE;							// x͈͕ω׸ސݒ
					}
					break;
				default : tempRangeChange = TRUE;						// x͈͕ω׸ސݒ(͏ł̂ݎ)
			}
			if (tempRangeChange) {									// x͈͕ωŁA
				if (BattData.Temperature <= T0) {						// T0͈͂ŁA
					if (ADCS.VBAT <= BAT_VOLTAGE_MAX_T0) {					// ٓd4.10VȉŁA
						ChargeParameters.Voltage = BAT_VOLTAGE_MAX_T0;		// ő[dd=4.10V~ِw
						ChargeParameters.Current = BattData.MaxCurrent;		// ő[dd=1Cw
					}
					else {													// ٓd4.10VzŁA
						ChargeParameters.Voltage = BAT_VOLTAGE_MAX;			// ő[dd=4.20V~ِw
						ChargeParameters.Current = BattData.MaxCurrent/2;	// ő[dd=0.5Cw
					}
					lastTempRange = T0;										// x͈T0w
				}
				else {													// T0͈͈ȊOŁA
				// T0ȊO1.0Cő[dd܂Aő[ddقȂ܂B
					ChargeParameters.Current = BattData.MaxCurrent;		// ő[dd=1.0Cw
					if (BattData.Temperature <= T1) {						// T1͈͂ŁA
						ChargeParameters.Voltage = BAT_VOLTAGE_MAX;			// ő[dd=4.20V~ِw
						lastTempRange = T1;									// x͈T1w
					}
					else if (BattData.Temperature <= T2) {					// T2͈͂ŁA
						ChargeParameters.Voltage = BAT_VOLTAGE_MAX_T2;		// ő[dd=4.15V~ِw
						lastTempRange = T2;									// x͈T2w
					}
					else {													// T3͈͂ŁA
						ChargeParameters.Voltage = BAT_VOLTAGE_MAX_T3;		// ő[dd=4.10V~ِw
						lastTempRange = T3;									// x͈T3w
					}
				}
			}

			// If both charge voltage and current are below limits, the PWM output may
			// be increased.
			if (ADCS.VBAT < (ChargeParameters.Voltage - BAT_VOLTAGE_HYST) &&	// [ddƏ[dd˽ؼ܂߂ċɌxŁA
			   ADCS.avgIBAT < (ChargeParameters.Current - BAT_CURRENT_HYST)) {

				if(!PWM_IncrementDutyCycle()) {									// PWMޭè ّAsŁA
#ifdef ABORT_IF_PWM_MAX
					SetErrorFlag(ERR_PWM_CONTROL);								// PWMُ׸ސݒ
					ChargeParameters.NextState = ST_ERROR;						// ԕُԂɕύX
					error = TRUE;												// ُ׸ސݒ
#endif
				}
			} 
			if (ADCS.VBAT > (ChargeParameters.Voltage + BAT_VOLTAGE_HYST) ||	// [ddƏ[dd˽ؼ܂߂Ăǂ炩xzŁA
			    ADCS.avgIBAT > (ChargeParameters.Current + BAT_CURRENT_HYST)) {
				if(!PWM_DecrementDutyCycle()) {									// PWMޭè ٌAsŁA
#ifdef ABORT_IF_PWM_MIN
					SetErrorFlag(ERR_PWM_CONTROL);								// PWMُ׸ސݒ
					ChargeParameters.NextState = ST_ERROR;						// ԕُԂɕύX
					error = TRUE;												// ُ׸ސݒ
#endif
				}
			}
		}
	} while (!HaltNow() && !error);
	return(ChargeParameters.NextState);		// Charge()Ɏ̏ԂԂ܂B
											// ُ킪NꍇA͏[d̎̏Ԃł͂Ȃʂ̏Ԃ܂B
}

/*! \brief dœdr[d
 *
 * ̊֐HaltNow()TRUEԂA܂\ref ABORT_IF_PWM_MIN
 * \ref ABORT_IF_PWM_MAX`APWMُ킪N܂ŁAdrɑ΂
 * (ChargeParameters.VoltageŐݒ肳ꂽ)d܂B\n
 * [dd́} \ref BAT_VOLTAGE_HYST ŕς蓾܂B\n
 * 呕u[d֎~ꍇAv킪~APWMo͂Ƃ܂Bdr[
 * d֎~̍}͂₳ȂȂAv킪ĂъJnď[dĊJ܂B
 *
 * \retval ChargeParameters.NextState	̒iKI̎̏
 * ُȋNȂȂACharge()ŉݒ肳ꂽł傤BȂ
 * ΁AHaltNow()V̏Ԃݒ肷ł傤B
 */
unsigned char ConstantVoltage(void)
{
	unsigned char error = FALSE,
				  wasStopped = FALSE;
	
	do{
		ADC_Wait();										// A/Dϊҋ@
		if (BattControl[BattActive].ChargeInhibit) {	// 呕u[d֎~}ȂA[dꎞ~
			wasStopped = TRUE;							// (͒ʐM̑h߂łB)
			Time_Stop();
			OCR1B = 0;
		}
		else {											// ֎~vȂŁA[dp
			if (wasStopped) {
				wasStopped = FALSE;
				Time_Start();							// (vϐ͂ɂؾĂ܂B)
			}
			if (ADCS.VBAT < (ChargeParameters.Voltage - BAT_VOLTAGE_HYST)) {	// [ddChargeParameters.Current}BAT_VOLTAGE_HYSTɒ(+)

				if(!PWM_IncrementDutyCycle()) {			// ޭè ّs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MAX
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			} else if (ADCS.VBAT > (ChargeParameters.Voltage + BAT_VOLTAGE_HYST)) {	// [ddChargeParameters.Current}BAT_VOLTAGE_HYSTɒ(-)

				if(!PWM_DecrementDutyCycle()) {			// ޭè ٌs\ŁAُ׸ސݒAُԐݒ
#ifdef ABORT_IF_PWM_MIN
					SetErrorFlag(ERR_PWM_CONTROL);
					ChargeParameters.NextState = ST_ERROR;
					error = TRUE;
#endif
				}
			}
		}
	} while (!HaltNow() && !error);
	return(ChargeParameters.NextState);		// Charge()Ɏ̏ԂԂ܂B
											// ُ킪NꍇA͏[d̎̏Ԃł͂Ȃʂ̏Ԃ܂B
}

/*! \brief [d~鎞̔
 *
 * ̊֐HaltParameters.HaltFlagsō}ꂽ̂ɈˑҰ]A
 * [d~邩ۂTRUE܂FALSEԂ܂B\n
 * āAԒ(dr)łُ̈׸ނݒ肳꓾܂B\n
 *
 * ֐͓drxxAdOKABatteryCheck()TRUEԂ
 * ܂Bُ킪oꂽꍇAAgُ׸ނݒ肳A
 * ChargeParameters.NextStateK؂ȏԂɕύX܂B
 *
 * \retval TRUE		ݒ~
 * \retval FALSE	ݒ~ł͂Ȃ
 *
 * \note ~׸ނ̒`ɂĂchargefunc.hB
 * \note Ԓ߂Œ~邱Ƃ͈ʓIɈlł͂܂B
 * \note HALT_ON_VOLTAGE_DROPݒ肳ꂽꍇA[d֐ĂԑOHaltParameters.VBATMaxCharge()ؾĂׂłB
 *
 * \todo Ẅُ팟"D揇"͑vł?
 */
unsigned char HaltNow(void)
{
	unsigned char i, halt = FALSE;

	ADC_Wait();		// A/Dϊ񊮗ҋ@
	NTCLookUp();	// x擾

	for (i = 0x01; i != 0; i <<= 1) {	// HaltFlagsɏ]A/Dϊl]
		if (HaltParameters.HaltFlags & i) {
			switch (i) {
			case HALT_VOLTAGE_DROP:								// dቺ
				if (ADCS.VBAT > HaltParameters.VBATMax ||			// VBAT>݂܂ł̍őd܂͎呕ȕ[d֎~ŁA
				  BattControl[BattActive].ChargeInhibit) {
					HaltParameters.VBATMax = ADCS.VBAT;				// ݂܂ł̍ődXV
				} else if((HaltParameters.VBATMax - ADCS.VBAT) >=	// VBAT݂܂ł̍ődAVቺdŁA
				          HaltParameters.VoltageDrop) {
					halt = TRUE;									// ~׸ސݒ
				}
			break;
			case HALT_VOLTAGE_MAX:								// őd
				if (ADCS.VBAT >= HaltParameters.VoltageMax) {		// VBATődŁA
					halt = TRUE;									// ~׸ސݒ
				}
				break;
			case HALT_CURRENT_MIN:								// ŏd
				if (ADCS.avgIBAT <= HaltParameters.CurrentMin &&	// IBATŏd呕ȕ[d֎~ȂŁA
				    !BattControl[BattActive].ChargeInhibit) {
					halt = TRUE;									// ~׸ސݒ
				}
				break;
			case HALT_TEMPERATURE_RISE:							// x㏸
				if (ADCS.rawNTC > HaltParameters.LastNTC) {			// x>OxŁA
					HaltParameters.LastNTC = ADCS.rawNTC;			// OxXV
					Time_Set(TIMER_TEMP,0,30,0);					// 30bvn
				} else  if ((HaltParameters.LastNTC - ADCS.rawNTC) >=		// xOxAx㏸xŁA
				  (BattData.ADCSteps * HaltParameters.TemperatureRise)) {
					if (Time_Left(TIMER_TEMP))  {							// 30bȓȂA
						halt = TRUE;										// ~׸ސݒ
					} else {												// 30bȏȂA
						HaltParameters.LastNTC = ADCS.rawNTC;				// x𒼑OxƂĐݒ
						Time_Set(TIMER_TEMP,0,30,0);						// 30bvn
					}
				}
			break;
			case HALT_TIME:										// [dԌ
				if (!Time_Left(TIMER_CHG)) {						// [dԌo߂ŁA
					halt = TRUE;									// ~׸ސݒ
					if (HaltParameters.HaltFlags & HALT_FLAG_EXHAUSTION) {	// Ղł̒~ŁA
							PWM_Stop();										// PWM~
							BattControl[BattActive].Enabled = FALSE;		// dr֎~
							BattData.Exhausted = TRUE;						// dr׸ސݒ
							SetErrorFlag(ERR_BATTERY_EXHAUSTED);
							ChargeParameters.NextState = ST_ERROR;			// ̏Ԃُُɐݒ
					}
				}
			break;
			default:	// ŏIׂł͂܂BMISRAK̂߂ɕKvƂ܂B
			break;
			}
		}
	}
	/* W */
	if ((BattData.Temperature < HaltParameters.TemperatureMin) ||	// drxႷA܂͍ŁA
	    (BattData.Temperature > HaltParameters.TemperatureMax)) {
		PWM_Stop();													// PWM~
		SetErrorFlag(ERR_BATTERY_TEMPERATURE);						// xُ׸ސݒ
		ChargeParameters.NextState = ST_ERROR;						// ̏Ԃُُɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	if (!BatteryCheck()) {											// drOKłȂ΁A
		PWM_Stop();													// PWM~
		ChargeParameters.NextState = ST_INIT;						// ̏Ԃɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	if (!ADCS.Mains) {												// dOKłȂ΁A
		PWM_Stop();													// PWM~
		ChargeParameters.NextState = ST_SLEEP;						// ̏Ԃx~(ذ)ɐݒ
		halt = TRUE;												// ~׸ސݒ
	}
	return(halt);												// ~׸ނƋɕA
}
